using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// The SavedSearchesForm displays a list of records Manager Saved Searches.
	/// </summary>
	public class SavedSearchesForm : System.Windows.Forms.Form
	{
		public SavedSearchesForm(ClientSession session, byte nQueryType)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_session = session;
			m_nQueryType = nQueryType;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listView1 = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.columnHeader1,
																						this.columnHeader2});
			this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView1.FullRowSelect = true;
			this.listView1.Location = new System.Drawing.Point(0, 0);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(440, 229);
			this.listView1.TabIndex = 0;
			this.listView1.View = System.Windows.Forms.View.Details;
			this.listView1.DoubleClick += new System.EventHandler(this.listView1_DoubleClick);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Component Type";
			this.columnHeader1.Width = 132;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Saved Search Name";
			this.columnHeader2.Width = 500;
			// 
			// SavedSearchesForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 229);
			this.Controls.Add(this.listView1);
			this.Name = "SavedSearchesForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "SavedSearchesForm";
			this.Load += new System.EventHandler(this.SavedSearchesForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#region events
		private void SavedSearchesForm_Load(object sender, System.EventArgs e)
		{
			long userId = m_session.getUserController().getUserId();
			string filter =
			"<Filters>" +
				//TODO do we want to filter on specific types
				//"<Item Name=\"FlPlnCmpntDefID\">21</Item>" + 
				"<Item Name=\"UsrGrpID\">" + userId + "</Item>" + 
				"<Item Name=\"PublicQryFlg\">1</Item>" + 
				"<Item Name=\"QueryType\">" + m_nQueryType + "</Item>" + 
			"</Filters>";
			
			string xml = m_session.getQueryController().getQueryList(filter);
			XmlDocument doc = new XmlDocument();
			doc.LoadXml(xml);
			XmlElement root = doc.DocumentElement;
			XmlNodeList items = root.ChildNodes;
			int count = items.Count;
			if(count > 0)
			{
				for(int i = 0; i < items.Count; i++)
				{
					XmlElement item = (XmlElement)items.Item(i);
					string strFlPlnCmpntDefNm = item.Attributes.GetNamedItem("FlPlnCmpntDefNm").Value;
					string strQueryNm = item.Attributes.GetNamedItem("QueryNm").Value;
					long nQueryID = System.Convert.ToInt32(item.Attributes.GetNamedItem("QueryID").Value);
					
					//listView1.Items.Add
					ListViewItem lvItem = listView1.Items.Add(new ListViewItem(
						new string[]{strFlPlnCmpntDefNm,strQueryNm}));
					lvItem.Tag = nQueryID;
				}
			}
			else
			{
				string queryType = "Saved";
				if(m_nQueryType == (byte)IRMConstants.QueryTypes.LIFE_CYCLE)
				{
					queryType = "Life Cycle";
				}
				MessageBox.Show(this,"There are no " + queryType + " Queries available. To use this feature you must construct some " + queryType + " queries and assign them to the user who will log on to this application",
								"Information",MessageBoxButtons.OK,MessageBoxIcon.Information);
			}
		}

		private void listView1_DoubleClick(object sender, System.EventArgs e)
		{
			IEnumerator items = listView1.SelectedItems.GetEnumerator();
			items.MoveNext();
			ListViewItem lvi = (ListViewItem)items.Current;
			//Get saved search xml and leave
			m_xmlQuery = m_session.getQueryController().getQueryById((long)lvi.Tag);
			DialogResult = DialogResult.OK;
			this.Close();
		}
		#endregion

		public string XMLQuery
		{
			get
			{
				return m_xmlQuery;
			}
		}

		#region MemberVariables
		private ClientSession m_session;
		private string m_xmlQuery;
		private byte m_nQueryType;

		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion
	}
}
